#!/usr/bin/perl
#
# wdivulge - find private files 
#
# Output: varies depending on lists
#
# Author:        Blake
# Contact:       blake@soldierx.com
# Last Updated:  12/06/2010
# Version:       0.1.2
  package main;
  use strict;
  use LWP::UserAgent;
  use Cwd;
  #$Config{useithreads} or die('Recompile Perl with threads to run this program.');
  use threads('yield', 'stack_size' => 64*4096, 'exit' => 'threads_only', 'stringify');
  use threads::shared;

  my ($url, $start, $max, $dir, $options, $mode, $verbose) = 0;
  
 
  if (substr(@ARGV[0],0,1) eq "-")
  {
       $options = 1;
  }
  else
  {
       print("[ wdivulge ] Error: must supply mode and options\n");
       display_help();
  }
  while($options eq 1)
  {
       if (@ARGV[0] eq "-u")
       {
            # start url
	    $url = @ARGV[1];
	    shift(@ARGV); #remove option
	    shift(@ARGV); #remove value
       }
       elsif (@ARGV[0] eq "-a")
       {
            # auto mode
	    $mode = "auto";
	    shift(@ARGV); #remove option
       }
       elsif (@ARGV[0] eq "-m")
       {
            # count
	    $max = @ARGV[1];
            print("[ wdivulge ] Max set to: $max\n");
	    shift(@ARGV); #remove option
	    shift(@ARGV); #remove value
       }
       elsif (@ARGV[0] eq "-d")
       {
            # directory
	    $dir = @ARGV[1];
	    shift(@ARGV); #remove option
	    shift(@ARGV); #remove value
       }
       elsif (@ARGV[0] eq "-v")
       {
            # verbose
	    $verbose = 1;
	    shift(@ARGV); #remove option
       }
       else
       {
            #remove unexpected input
	    shift(@ARGV);
       }
       
       $options = 0;
       if (substr(@ARGV[0],0,1) eq "-")
       {
            $options = 1;
       }
  }
  
  #if ($mode eq "auto")
     auto_attack($max, $dir, $verbose);

#Sub Name:   manual_attack
sub manual_attack
{
   my $time1 = time;
   my $final = $max;
   $max = int($max / 8);
   my $filestart;
   #my $thread1 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, $start, ($start + $max));
   #my $thread2 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + $max + 1), ($start + ($max * 2)));
   #my $thread3 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($max * 2) + 1), ($start + ($max * 3)));
   #my $thread4 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($max * 3) + 1), ($start + ($max * 4)));
   #my $thread5 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($max * 4) + 1), ($start + ($max * 5)));
   #my $thread6 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($max * 5) + 1), ($start + ($max * 6)));
   #my $thread7 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($max * 6) + 1), ($start + ($max * 7)));
   #my $thread8 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($max * 7) + 1), ($start + ($final)));

   my @ReturnData;
   # Loop through our threads and make sure they are done
   foreach my $thr (threads->list())
   {
      @ReturnData = $thr->join();
      print("[ wdivulge ] Attack Thread #$thr returned ", join(', ',@ReturnData),"\n"); #report success or failure
   }
   my $time2 = time;
   #print("Attack Thread #$thread1 returned ", join(', ', @ReturnData),"\n");
   print("[ wdivulge ] Time Taken: " . ($time2 - $time1) . "\n");

}

#Sub Name:   auto_attack
sub auto_attack
{
   my($max, $dir, $verbose) = @_;
   my $pwd = cwd;
   # THIS NEEDS CODE TO READ ALL FILES IN /LISTS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   my @numfnames = read_file("$pwd\/lists\/files.txt");
   my $time1 = time;
   my ($smartid, $idtype, $filestart, $digits, $filetype, $dmax);
   
   while($smartid = shift(@numfnames))
   {
      ($idtype, $filestart, $digits, $filetype, $max) = process_smartid($smartid, $max);
      if($idtype == 1)
      {
         $dmax = int($max / 10);
	 
	 #boom goes the dynamite
	 my $thread1 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, $start, ($start + $dmax), $verbose);
         my $thread2 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + $dmax + 1), ($start + ($dmax * 2)), $verbose);
         my $thread3 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 2) + 1), ($start + ($dmax * 3)), $verbose);
         my $thread4 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 3) + 1), ($start + ($dmax * 4)), $verbose);
         my $thread5 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 4) + 1), ($start + ($dmax * 5)), $verbose);
         my $thread6 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 5) + 1), ($start + ($dmax * 6)), $verbose);
         my $thread7 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 6) + 1), ($start + ($dmax * 7)), $verbose);
         my $thread8 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 7) + 1), ($start + ($dmax * 8)), $verbose);
         my $thread9 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 8) + 1), ($start + ($dmax * 9)), $verbose);
         my $thread10 = threads->create(\&get_files_thread, $url, $filestart, $filetype, $digits, ($start + ($dmax * 9) + 1), ($start + ($max)), $verbose);
	 
	 my @ReturnData;
         # Loop through our threads and make sure they are done
         foreach my $thr (threads->list())
         {
            @ReturnData = $thr->join();
            print("[ wdivulge ] Attack Thread #$thr returned ", join(', ',@ReturnData),"\n"); #report success or failure
         }
      }
      elsif($idtype == 2)
      {
         print("[ wdivulge ] Type 2 is not yet handled.\n");
      } 
   }
   
   my $time2 = time;
   #print("Attack Thread #$thread1 returned ", join(', ', @ReturnData),"\n");
   print("[ wdivulge ] Time Taken: " . int(($time2 - $time1)/60) . " minutes and " . int(($time2 - $time1)%60) . " seconds.\n");
}

#Sub Name:   get_files_thread
sub get_files_thread
{
   my($url, $filestart, $filetype, $digits, $start, $max, $verbose) = @_;
   my $counter = 0;
   my $count = 0;
   my $return = "failure";
   my $threadID = threads->tid();
   
   print("[ wdivulge ] Attack Thread #$threadID started!\n");
   
   my $ua = LWP::UserAgent->new;
   $ua->agent("wdivulge/0.1 ");
   $ua->timeout(20);

   for ($counter = $start; $counter <= $max; $counter++)
   {
	$count = $counter;
	fmt_digits($count, $digits);
	
        #system("wget $start_url$count$end_url &")
		   
	my $req = HTTP::Request->new(GET => "$url\/$filestart$count$filetype");
	# Pass request to the user agent and get a response back
        my $res = $ua->request($req);
	# Check the outcome of the response
        if ($res->is_success) 
        {
           print "Success:\t$url\/$filestart$count$filetype\n";
           open(OUT, ">$filestart$count$filetype");
           print OUT ($res->content);
           close(OUT);
	   $return = "success";
        }
	else 
	{
	   if($verbose)
	   {
	      print "[ wdivulge ] " . $res->status_line, " $url\/$filestart$count$filetype\n";
	   }
	}
   }
   return $return;
}

# Sub Name:       fmt_digits
# Purpose:        Format number with specified number of digits
# Last Modified:  10/27/2008
sub fmt_digits
{
    my ($number, $digits) = @_;
    if (length($number) < $digits)
    {
         for (my $i = length($number); $i < $digits; $i++)
         {
             $number = "0" . $number;
         }
	 # we changed number, so we need to change the passed variable
	 $_[0] = $number;
    }
}

# Sub Name:      read_file
# Purpose:       read in a file for attack names
# Last Modified: 11/10/2009
sub read_file
{
   # needs code to determine numeric or alpha
   # needs code to determine file type!
   my ($filename) = @_;
   my @filedata;
   print("[ wdivulge ] reading file: $filename\n");
   open (MYFILE, $filename);
   while (<MYFILE>) 
   {
      chomp;
      #unshift(@numfnames,"$_");
      push(@filedata,"$_");
   }
   close (MYFILE);
   return @filedata;
}

# Sub Name:      process_smartid
# Purpose:       reads in a smart id and returns values
# Last Modified: 12/03/2010
sub process_smartid
{
   #GET RID OF ALL GLOBAL VARIABLES
   my ($smartid, $max) = @_;
   my ($idtype, $filestart, $digits, $filetype) = 0;
   if($smartid =~ m/"(.*)"\[(#*)\]\\"(\.\w{3})"/)
   {
      print("[ wdivulge ] Going after files of pattern $1$2$3\n");
      $idtype = 1; #numeric
      $filestart = $1;
      $digits = length($2);
      $filetype = $3;
      if ((length($max) < $digits) || (length($max) > $digits)) # avoid $max bugs 
      {
	 $max = ""; # prepare to reset max
         for (my $i = 0; $i < $digits; $i++)
         {
            $max = "9" . $max;
         }
	print("[ wdivulge ] New Max: $max\n");
      }
   }
   elsif($smartid =~ m/"(.*)"\\"(\.\w{3})"/)
   {
      print("[ wdivulge ] Going after files of pattern $1$2\n");
      $idtype = 2; #alpha
      $filestart = $1;
      $digits = 0;
      $filetype = $3;
   }
   return ($idtype, $filestart, $digits, $filetype, $max); #needs to return max eventually
      
}
#Sub Name:     display_help
sub display_help
{
    die("\twdivulge.pl -u \"http://www.site.com/private\" -a -m 1000 -d private
    \t-u   - URL
    \t-a   - Auto Mode (default)
    \t-m   - Max number to count to
    \t-v   - Verbose
    \n");
}
